import os
import grok
from grok import index
from hurry.query.query import Query, Text
from hurry.query import Eq
from waeup.app import University
from waeup.interfaces import ICourse, ICertificateCourse
from waeup.student.interfaces import IStudent
from zope.app.catalog.interfaces import ICatalog
from zope.app.intid.interfaces import IIntIds
from zope.component import getUtility
from zope.component.interfaces import ComponentLookupError


class StudentIndexes(grok.Indexes):
     grok.site(University)
     grok.name('students_catalog')
     grok.context(IStudent)

     name = index.Field(attribute='name')


class StudentSearch(grok.View):
    grok.context(University)

    def update(self, query=None):
        self.search_result = []
        if query is not None:
            self.search_result = self.search_context(query)
            print "RESULT: ", list(self.search_result)

    def search_context(self, query):
        result = Query().searchResults(
            Eq(('students_catalog', 'name'), query)
            )
        return result
    
class CourseIndexes(grok.Indexes):
     grok.site(University)
     grok.name('courses_catalog')
     grok.context(ICourse)

     code = index.Field(attribute='code')
     title = index.Text(attribute='title')

class CourseCertificatesIndexes(grok.Indexes):
     grok.site(University)
     grok.name('certcourses_catalog')
     grok.context(ICertificateCourse)

     course_code = index.Field(attribute='getCourseCode')

@grok.subscribe(ICourse, grok.IObjectAddedEvent)
def handleCourseAdd(obj, event):
     """Index an added course with the local catalog.

     Courses are not indexed automatically, as they are not a
     dictionary subitem of the accompanied site object
     (`IUniversity`). I.e. one cannot get them by asking for
     ``app['FACCODE']['DEPTCODE']['COURSECODE']`` but one has to ask for
     ``app.faculties['FACCODE']['DEPTCODE'].courses['COURSECODE']``.

     Once, a course is indexed we can leave the further handling to
     the default component architechture. At least removals will
     be handled correctly then (and the course unindexed).
     """
     try:
          cat = getUtility(ICatalog, name='courses_catalog')
     except ComponentLookupError:
          # catalog not available. This might happen during tests.
          return
     intids = getUtility(IIntIds)
     index = cat['code']
     index.index_doc(intids.getId(obj), obj)
